/*
 * Instant Developer Next
 * Copyright Pro Gamma Spa 2000-2016
 * All rights reserved
 */

var App = App || {};

if (module)
  App.DataSchema = require("../dataschema");


/**
 * @class A DocumentSchema Object
 * @param {Object} dm - datamap owner
 * @param {Object} defprop - definition of the schema
 * */
App.DocumentSchema = function (dm, defprop)
{
  if (module && !App.View)
    App = require("../requireAll");
  //
  App.DataSchema.call(this, dm, defprop);
  //
  this.id = "";
  this.className = "";
  this.baseMD = null;
  this.properties = [];
  this.collections = [];
  this.relatedDocs = [];
  this.services = [];
  this.fieldMap = {};
  this.allowRemoteCall = false;
  this.allowRemoteCallMethods = [];
};

// Make App.DocumentSchema extend App.DataSchema
App.DocumentSchema.prototype = new App.DataSchema(true);


/**
 * Return the definition of a property given the name or the index
 * @param {String/Integer} prop
 * */
App.DocumentSchema.prototype.getPropDefinition = function (prop)
{
  if (typeof prop === "number")
    return this.properties[prop];
  else {
    for (var i = 0; i < this.properties.length; i++) {
      if (this.properties[i].name === prop)
        return this.properties[i];
    }
  }
};


/**
 * Return the definition of a collection given the name or the index
 * @param {String/Integer} coll
 * */
App.DocumentSchema.prototype.getCollDefinition = function (coll)
{
  if (typeof coll === "number")
    return this.collections[coll];
  else {
    for (var i = 0; i < this.collections.length; i++) {
      if (this.collections[i].name === coll)
        return this.collections[i];
    }
  }
};


//export module for node
if (module)
  module.exports = App.DocumentSchema;
