/*
 * Instant Developer Next
 * Copyright Pro Gamma Spa 2000-2016
 * All rights reserved
 */


/* global module */

var App = App || {};

//
// import modules
if (module && !App.View) {
  App = require("../requireAll");
  App.xml2js = require("xml2js");
}

/**
 * @class Xml
 * Contains method to convert the XML into a JavaScript object, and vice versa
 */
App.Xml = {};


/**
 * Creates a javascript object from xml
 * @param {object} app
 * @param {string} xml
 * @param {object} options
 * @param {function} cb
 */
App.Xml.parse = function (app, xml, options, cb) {
  app;
  //
  // Check parser variable
  if (!App.xml2js)
    App.xml2js = xml2js;
  //
  // parse the document
  App.xml2js.parseString(xml, options, function (err, result) {
    if (err)
      cb(null, err);
    else
      cb(result);
  });
};


/**
 * Creates a xml  from javascript object
 * @param {object} app
 * @param {object} jso
 * @param {object} options
 */
App.Xml.stringify = function (app, jso, options) {
  app;
  //
  // Check parser variable
  if (!App.xml2js)
    App.xml2js = xml2js;
  //
  // return the xml
  return new App.xml2js.Builder(options).buildObject(jso);
};


//export module for node
if (module)
  module.exports = App.Xml;
