/*
 * Instant Developer Next
 * Copyright Pro Gamma Spa 2000-2016
 * All rights reserved
 */

/* global module, require */

var App = App || {};

// translation maps
App.transCmdMap = {updateElement: "ue", removeChild: "rc", insertBefore: "ib", loadStyle: "ls",
  closeView: "cv", openView: "ov"};
App.transPropMap = {value: "v", style: "s", visible: "d", name: "n", className: "cn", class: "c",
  rownum: "rn", innerText: "t", innerHTML: "h"};
App.transStyleMap = {background: "b", backgroundColor: "bc", color: "c", fontStyle: "fs"};

if (module) {
  App.Database = require("./database");
  App.DataColumn = require("./datacolumn");
  App.DataMap = require("./datamap");
  App.DataRow = require("./datarow");
  App.DataSchema = require("./dataschema");
  App.DataGroup = require("./datagroup");
  App.Device = require("./device");
  App.Locale = require("./locale");
  App.DTT = require("./dtt").DTT;
  App.DTTRequest = require("./dtt").DTTRequest;
  App.DTTItem = require("./dtt").DTTItem;
  App.View = require("./view");
  App.Postgres = require("./postgres");
  App.SQLServer = require("./sqlserver");
  App.Oracle = require("./oracle");
  App.Pubsub = require("./pubsub");
  App.RemElem = require("./remelem");
//App.SQLite = require("./sqlite");
  App.Timer = require("./timer");
  App.Utils = require("./utils");
  App.Animation = require("./animation").Animation;
  App.AnimationSegment = require("./animation").AnimationSegment;
  App.Document = require("./do/document");
  App.Collection = require("./do/collection");
  App.DocumentProperty = require("./do/documentproperty");
  App.DocumentSchema = require("./do/documentschema");
  App.SyncFoundation = require("./do/syncfoundation");
  App.GAC = require("./gac.js");
  App.FS = require("./fs/fs");
  App.RemoteFS = require("./fs/remotefs");
  App.NodeDriver = require("./fs/nodedriver");
  App.File = require("./fs/file");
  App.Directory = require("./fs/directory");
  App.Url = require("./fs/url");
  App.Xml = require("./fs/xml");
  App.SecretKeeper = require("./fs/secretKeeper.js");
  App.Mailer = require("./fs/mailer");
  App.Stripe = require("./stripe");
  App.Sync = require("./sync");
  App.SyncPlugin = require("./syncPlugin");
  App.SyncCmd = require("./syncCmd");
  App.SyncDO = require("./syncDO");
  App.RemoteDriver = require("./remotedriver");
  App.PhantomJS = require("./phantom");
  App.Analytics = require("./analytics");
  App.HeaderList = require("./headerlist");
  App.Crypt = require("./crypt");
  App.ActiveDirectory = require("./activedirectory");
  App.RemotePlugin = require("./remoteplugin");
  App.WebApiEndpoint = require("./webapi/webapiendpoint");
  App.WebApiFoundation = require("./webapi/webapifoundation");
}


if (module)
  module.exports = App;
