/*
 * Instant Developer Next
 * Copyright Pro Gamma Spa 2000-2015
 * All rights reserved
 */

/* global cordova, StatusBar */

var Plugin = Plugin || {};

/*
 * Create plugin object
 */
Plugin.Preferences = {};


/*
 * Init plugin
 */
Plugin.Preferences.init = function ()
{
  if (Shell.isIOS()) {
    plugins.appPreferences.fetch(function (ris) {
      if (Shell.config.UIWebView) {
        Shell.UIWebView = true;
        console.warn("Using UIWebView (config)");
      }
      else {
        if (ris) {
          Shell.UIWebView = true;
          console.warn("Using UIWebView (preferences)");
        }
        else {
          Shell.UIWebView = false;
          console.warn("Using WKWebView");
        }
      }
    }, function (err) {
      console.warn("Cannot get preferences: " + err);
    }, "UIWebView");
  }
};


/*
 * Show the app preferences
 * @param {type} req - pluginmanager.js request obj
 * @returns {undefined}
 */
Plugin.Preferences.show = function (req)
{
  plugins.appPreferences.show(function (ris) {
  }, function (err) {
  });
};


/*
 * Fetch an app preference
 * @param {type} req - pluginmanager.js request obj
 */
Plugin.Preferences.fetch = function (req)
{
  plugins.appPreferences.fetch(function (result) {
    req.setResult(result);
  }, function (error) {
    req.setError(error);
  }, req.params.key);
};


/*
 * Fetch an app preference
 * @param {type} req - pluginmanager.js request obj
 */
Plugin.Preferences.store = function (req)
{
  plugins.appPreferences.store(function (result) {
  }, function (error) {
  }, req.params.key, req.params.value);
};
